package cn.com.qmth.scancentral.service.impl;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.springframework.stereotype.Service;

import cn.com.qmth.scancentral.service.AsyncTaskService;
import cn.com.qmth.scancentral.util.FileUtil;
import cn.com.qmth.scancentral.vo.asynctask.AsyncTaskVo;
import cn.com.qmth.scancentral.vo.subject.DataExportTaskVo;

@Service
public class AsyncTaskServiceImpl implements AsyncTaskService {

    // 30分钟
    private static long timeOut = 30 * 60 * 1000;

    private final static Map<String, AsyncTaskVo> tasks = new ConcurrentHashMap<>();

    private final static Map<String, Long> taskActive = new ConcurrentHashMap<>();

    @Override
    public void addTask(AsyncTaskVo vo) {
        tasks.put(vo.getTaskId(), vo);
        taskActive.put(vo.getTaskId(), System.currentTimeMillis());
    }

    private void updateTaskActive(String taskId) {
        taskActive.put(taskId, System.currentTimeMillis());
    }

    @Override
    public void clearTimeOut() {
        Long now = System.currentTimeMillis();
        for (String k : taskActive.keySet()) {
            if (now - taskActive.get(k) > timeOut) {
                AsyncTaskVo vo = tasks.get(k);
                if (vo != null) {
                    if (vo.getTempDir() != null && vo.getTempDir().exists()) {
                        FileUtil.deleteDirectory(vo.getTempDir());
                    }
                    tasks.remove(k);
                }
                tasks.remove(k);
            }
        }
    }

    @Override
    public DataExportTaskVo getDataExportTask(String taskId) {
        updateTaskActive(taskId);
        return (DataExportTaskVo) tasks.get(taskId);
    }

}
